// スレタイplus for V2C R2013092303

//【登録場所】 "V2C\script\system\subject.js"
//【内容】 板のスレ一覧（subject.txt）を変更
//【備考】・checkSubject(ss,bd,cx)はsubject.txtを実際に取得した時にのみ実行されます。
//　　　　　（例えばHTTPレスポンスコードが 304 Not Modified. の時は実行されない。）
//　　　　・現在（2.10.0 [R20120923]）ローカル板・Twitter仮想板でcheckSubject(ss,bd,cx)は実行されませんが、
//　　　　　将来実行される可能性があります。 
//　　　　・subject.jsを変更した時は「ファイル」メニューの「再読み込み」→「subject.js」で再読み込みすることができます。 
function checkSubject(ss,bd,cx){//subject.txtを取得した後解析する前に実行
	/* 機能を有効にしたい場合、下の各行頭//を削除してください  */
	ss=ttp(ss,bd,cx); //スレタイplus
	//ss=sort924ToBottomLine(ss,bd,cx); //スレッド924を下げてスレタイの先頭に★を追加
	return ss;
}

function sort924ToBottomLine(ss,bd,cx) {
	if(!bd.bbs.is2ch){//||(bd.key!='software')
		return ss;//これを入れないとまちBBS形式のsubjectが更新できなくなる
	}
	var re=new RegExp('^(\\d+)\\.dat<>(.+) \\((\\d+)\\)$','gm');//dat各行のマッチ [1]dat番[2]スレタイ[3]レス数
	var ls=[],ls9=[];//ls:変更なしの行,ls9:スレッド924用
	var rt;
	while(rt=re.exec(ss)){//取得したsubject.txtがマッチするか確認
		if(rt[1][0]=='9'){//dat番号が9から始まる場合
			ls9.push(rt[1]+'.dat<>★ '+rt[2]+' ('+rt[3]+')\n');
		}else{
			ls.push(rt[0]+'\n');
		}
	}
	if(ls.length===0)return ss;
	return ls.concat(ls9).join('');//変更なしの行の配列にスレッド924用の配列を結合
}

/*
ss … 取得したsubject.txt 
bd … 板オブジェクト 
cx … （現在はダミー）
*/
jl=java.lang;
awt=java.awt;

function ttp(ss,bd,cx){
	if(!bd.bbs.is2ch)return ss;
	switch(bd.key+""){//無効にしたい板はコメントアウト
		case 'eqplus'://臨時地震+
		case 'be'://面白ネタnews
		case 'nandemo'://なんでも質問
		case 'argue'://朝生
		case 'bizplus'://ビジネスnews+
		case 'newsplus'://ニュース速報+
		case 'wildplus'://ニュース二軍+
		case 'moeplus'://萌えニュース+
		case 'mnewsplus'://芸スポ速報+
		case 'femnewsplus'://ほのぼのnews+
		case 'dqnplus'://痛いニュース+
		case 'scienceplus'://科学ニュース+
		case 'owabiplus'://お詫び+
		case 'liveplus'://ニュース実況+
		case 'liveplus'://ニュース実況+
		case 'news'://ニュース速報
		case 'news4plus'://東アジアnews+
		case 'news5plus'://ニュース国際+
		case 'qa'://初心者の質問
		case 'gline'://ガイドライン
		case 'offevent'://突発OFF
		case 'chiri'://地理お国自慢
		case 'ticketplus'://Walker+
		case 'ex'://カップル
		case 'news4viptasu'://ニュー速VIP+
		case 'poverty'://ニュー速(嫌儲)
		case 'bbynews'://速報headline<-本家で扱っていない
		case 'phs'://携帯・ＰＨＳ<-本家で扱っていない
			break;
		default :
			return ss;
	}
//--------------------------------------
// 設定
//--------------------------------------
	// ▼各種ファイル名等(systemフォルダに配置) 新たにファイルを追加/削除する場合はここを編集
	//   str_add :スレタイ先頭に付加する文字列
	//   flag    :比較の対象(0:BEID,1:記者,2:名前,3:ID),
	// ★th_shift:該当スレを 0:通常表示,1:上げる,2:下げる,3:非表示
	var ar_replace=[
		{filename:"myngbe.txt",   str_add:"【NGBE】",  file_encode:"UTF-8",flag:0,th_shift:2},//NGBE
		{filename:"myokbe.txt",   str_add:" ⇒ ",      file_encode:"UTF-8",flag:0,th_shift:1},//注目BE
		{filename:"myngkisya.txt",str_add:"【NG記者】",file_encode:"UTF-8",flag:1,th_shift:2},//NG記者
		{filename:"myokkisya.txt",str_add:" ⇒ ",      file_encode:"UTF-8",flag:1,th_shift:1} //注目記者
	];
	// ▼既定リストの設定
	//   use_label   :V2Cに設定されたNG用ラベルをスレタイ先頭に付加する文字列として true:使用する,false:使用しない
	//                ただしラベルがBEIDそのままの場合や空白の場合はstr_addが使用される
	//   label_format:use_labelがtrueのときスレタイ先頭に付加する文字列のフォーマット(%label%はラベルに置換される)
	var ar_replace_sys={
		//BE情報のないスレ(クローラがBE情報を取得できなかったスレ,スレッド924含む) 嫌儲のみ有効,BE隠しかも?
		hidden: {str_add:"【notbe?*】",th_shift:2},
		//情報未取得(クローラが情報未取得)のスレ
		noinfo: {str_add:"【noinfo*】",th_shift:2},
		//V2Cに登録されたNGIDが立てたスレ
		v2c_ngid: {str_add:"【NGID*】",th_shift:2},
		//V2Cに登録されたNGBEが立てたスレ
		v2c_ngbe: {str_add:"【NGBE*】",th_shift:2,use_label:true,label_format:'【%label%】'},
		//V2C保存用フォルダ内のNGBE.txt(Jane互換)
		v2c_ngbe_j: {str_add:"【NGBE*】",th_shift:2},
		//新参BE(BE情報の後ろに表示) threshold==0で無視
		newcomer: {str_add:"[新参BE]",th_shift:0,threshold:0}
	};
	// ▼鮮度判定の設定
	var fleshnesscheck=true;//鮮度判定を true:行う,false:行わない
	var fleshness=300*1000;//鮮度判定(ミリ秒)
	var cache_encode='UTF-8';//キャッシュの文字コード
	// ▼その他の設定
	var beid_padding=false;//BEIDに対し0埋め等のフォーマットを行う
	var beid_format="%1$06d";//BEIDのフォーマット 6桁まで0パディングする場合は"%1$06d"
	var title_spacing=false;
	var title_spacing_px=300;
	var bename_display=true;
	var getidfromtitle=true;//スレタイからBEIDを取得する(嫌儲のみ有効)
//--------------------------------------
// 設定ここまで
//--------------------------------------
	
	//var ar_all=['eqplus','be','nandemo','argue','bizplus','bizplus','newsplus','wildplus','moeplus','mnewsplus','femnewsplus','dqnplus','scienceplus','owabiplus','liveplus','liveplus','news','news4plus','news5plus','qa','gline','offevent','chiri','ticketplus','ex','news4viptasu','poverty','bbynews','phs'];
	var ar_sass=['eqplus','be','nandemo','argue','bizplus','bizplus','newsplus','wildplus','moeplus','mnewsplus','femnewsplus','dqnplus','scienceplus','owabiplus','liveplus','liveplus','news','news4plus','news5plus','qa','gline','offevent','chiri','ticketplus','ex','news4viptasu','poverty'];
	var ar_hacca=["poverty","news","newsplus","mnewsplus","be","bbynews","phs"];
	// ▼スレッド情報配信サーバURL 優先順に並べ、他の配信サイトを追加する場合はここに追記する
	var ar_server=[//type 0:anosono(json), 1:normal(txt), 2:subject(txt)
		{name:"hacca",url:"http://ame.hacca.jp/sasss/?i="+bd.key,type:1,ar_bd:ar_hacca},//薄荷飴 6分
		{name:"sass1",url:"http://sass.m35.coreserver.jp/thdat/"+bd.key+".txt",type:1,ar_bd:ar_sass},//本家1
		{name:"sass2",url:"http://sass.m35.coreserver.jp/thdatU/"+bd.key+".txt",type:1,ar_bd:ar_sass},//本家2
		{name:"anosono",url:"http://anosono.dyndns.tv/2ch/cache/"+bd.key+".json",type:0,ar_bd:["poverty"]},//5分
		{name:"kiki",url:"http://kiki.mods.jp/be/"+bd.key+"_subject.txt",type:2,ar_bd:["poverty","news"]}//ｽﾄｰｶｰ 10分
	];
	
	var v2cobj=v2c.getScriptObject();//V2Cが終了するまで記憶される
	if(!v2cobj)v2cobj={lastModified:null,lists:{}};
	
	if(bd.key+""!="poverty")getidfromtitle=false;//嫌儲以外ではスレタイからの抽出を行わない
	
	// ■スレッド情報配信サーバから情報を取得する
	var fs=java.io.File.separator;
	var dr=v2c.saveDir+fs+'script'+fs+'system'+fs;
	if(getidfromtitle===false){
		
		for(var i=0;i<ar_server.length;i++){//配信サイト
			if(in_array(ar_server[i].ar_bd,bd.key+"")===false)continue;
			//配信サイト・板ごとにファイルを確認
			var cache_name=dr+hash_md5(ar_server[i].name+'_'+bd.key)+'.txt';
			var loaded=false;
			if(fleshnesscheck){
				var cache_file=new java.io.File(cache_name);
				if(cache_file.exists()){//キャッシュが存在
					var time_now=new Date();
					var time_file=v2cobj.lastModified;//前回取得のlast-modifiedがあればそれを使う
					if(!time_file)time_file=cache_file.lastModified();
					if(time_now-time_file<fleshness){//経過時間が短い場合はキャッシュを使用
						file=v2c.readFile(cache_name,cache_encode);
						loaded=true;
						v2c.println('cache(fleshnesscheck):'+ar_server[i].name+'_'+bd.key);
					}
				}
			}
			if(!loaded){
				//var file=v2c.readURL(ar_server[i].url+"");//anosono(json)を使わない場合はこちらでもok この場合ﾊﾟｰﾐｯｼｮﾝSは不要
				var hr=v2c.createHttpRequest(ar_server[i].url+"");
				var file=hr.getContentsAsString();
				v2c.writeStringToFile(cache_name,file,cache_encode);
				var lm=hr.lastModified;
				v2cobj.lastModified=(lm)?lm:null;
				v2c.println('HttpRequest: '+ar_server[i].name+', '+bd.key);
			}
			
			var ls=[];
			if(ar_server[i].type==0){//anosono
				var obj=eval("("+file+")");
				if(obj.length===0)continue;
				for(var j=0;j<obj.length;j++){//共通の形式に変換
					if(obj[j].key)ls[obj[j].key]=obj[j];
				}
			}else if(ar_server[i].type==1){//normal
				var re=new RegExp('^([a-zA-Z0-9]*)\\t(\\d*)\\t(.*)\\t(.*)\\t(\\d*)\\t(.*)\\t$','gm');
				var rt;
				while(rt=re.exec(file)){
					var resid=(rt[3].match(/ID:(.+)/))?RegExp.$1:null;
					var be_id=(rt[5].length>0)?rt[5]:null;
					var be_nm=(rt[6].length>0)?rt[6]:null;
					var res_c=(rt[4].match(/([^<>]+ ★)/))?RegExp.$1:null;
					ls[rt[2]]={bbs:rt[1],key:rt[2],created:rt[2],"creator.id":resid,"creator.cap":res_c,"creator.name":rt[4],"creator.be.id":be_id,"creator.be.name":be_nm};
					//rt[0]全体,[1]板,[2]dat番(key),[3]ID,[4]名前欄,[5]BEID,[6]BE名
				}
			}else if(ar_server[i].type==2){//subject
				var re=new RegExp('^(\\d+)\\.dat<>(.+) \\((\\d+)\\)<>(\\d+)$','gm');//sbj各行のマッチ
				var rt;
				while(rt=re.exec(file)){
					ls[rt[1]]={"key":rt[1],"created":rt[1],"title":rt[2],"length":rt[3],"creator.be.id":be_id};
					//rt[0]全体[1]dat番[2]スレタイ[3]レス数
				}
			}
			if(ls.length>0)break;
		}
		if(!ls)return ss;
		else if(!ls.length)return ss;
	}else{
		ls=[];
	}
	
	// ■V2Cから渡されたsubjectの処理
	var re_sbj=new RegExp('^(\\d+)\\.dat<>(.+) \\((\\d+)\\)$','gm');//sbj各行のマッチ
	var ls_sbj=[];
	var rt_sbj;
	while(rt_sbj=re_sbj.exec(ss)){
		ls_sbj.push(rt_sbj);//rt_sbj[0]全体[1]dat番[2]スレタイ[3]レス数
	}
	
	// ■各種ユーザ指定リストの処理
	var ar_lists={};
	for(var i=0;i<ar_replace.length;i++){
		var fn=ar_replace[i].filename;
		var tmp_file=new java.io.File(dr+fn);
		var loaded=false;
		if(tmp_file.exists()){//リストファイルが存在
			var time_file=tmp_file.lastModified();
			if(v2cobj.lists[fn]){//リストのキャッシュが利用可能か確認
				if(v2cobj.lists[fn]['obj']){
					if(v2cobj.lists[fn]['obj']['lastModified']){
						if(v2cobj.lists[fn]['obj']['lastModified']>=time_file){//ファイルが更新されていない場合
							loaded=true;
							ar_lists[fn]=v2cobj.lists[fn];//前回以前に処理したものを利用
							v2c.println('cache(userlist):'+fn);
						}
					}
				}
			}
			if(loaded===false){
				var tmp_filestr=v2c.readLinesFromFile(dr+fn,ar_replace[i].file_encode);//array
				
				//var tmp_filestr=v2c.readStringFromFile(dr+fn,ar_replace[i].file_encode);//array
				
				if(tmp_filestr){
					ar_lists[fn]={};
					ar_lists[fn]['data']={};
					ar_lists[fn]['obj']=ar_replace[i];
					ar_lists[fn]['obj']['lastModified']=time_file;
					for(var j=0,l=tmp_filestr.length;j<l;j++){
						if(j==0/*&&ar_replace[i].file_encode=='UTF-8'*/){
							if((tmp_filestr[j].charCodeAt(0)).toString(16)=='feff'){
								tmp_filestr[j]=tmp_filestr[j].slice(1);
							}
						}
						var tmp_ar_line=tmp_filestr[j].split('<>');
						ar_lists[fn]['data'][tmp_ar_line[0]]=tmp_ar_line;
					}
					v2cobj.lists[fn]=ar_lists[fn];
					loaded=true;
					v2c.println('readFile(userlist):'+fn);
				}else{
					v2c.println('ERROR:readLinesFromFile('+fn+','+ar_replace[i].file_encode+')');
				}
			}
		}else{
			v2c.println('ファイルが存在しません:'+dr+fn);
		}
		if(!loaded){
			if(v2cobj.lists[fn]){//ファイル取得に失敗したら前回取得分を利用
				ar_lists[fn]=v2cobj.lists[fn];
				v2c.println('前回取得分を利用:'+fn);
			}else{
				ar_lists[fn]=null;
				v2c.println('読込失敗:'+fn);
			}
		}
	}
	
	// ■NGIDリストの処理
	if(getidfromtitle===false){
		var brdprops=v2c.readLinesFromFile(v2c.saveDir+fs+'log'+fs+'2ch_'+fs+bd.key+fs+'brdprops.txt','UTF-8');
		var ls_ngid={};
		if(brdprops){
			v2c.println('readFile(sys#NGID):brdprops.txt');
			for(var i=0;i<brdprops.length;i++){
				if(brdprops[i].match(/^ResHide\.ID:=.+/)){//NGIDの登録行
					var re_ngid=new RegExp('A:(\\d+):([a-zA-Z0-9+/]+)','gm');
					var rt_ngid;
					while(rt_ngid=re_ngid.exec(brdprops[i])){//NGID
						ls_ngid[rt_ngid[2]]=[rt_ngid[2]];
					}
				}
			}
		}
		ar_lists['#NGID']={"data":ls_ngid,"obj":ar_replace_sys.v2c_ngid};
		ar_lists['#NGID']['obj'].filename="#NGID";
		ar_lists['#NGID']['obj'].flag=3;//IDで比較
		
		v2cobj.lists['#NGID']=ar_lists['#NGID'];
	}
	
	// ■NGBEリストの処理
	var usrprops=v2c.readLinesFromFile(v2c.saveDir+fs+'usrprops.txt','UTF-8');
	var ls_ngbe={};
	if(usrprops){
		v2c.println('readFile(sys#NGBE):usrprops.txt');
		for(var i=0;i<usrprops.length;i++){
			if(usrprops[i].match(/^Be\.ID:=.+/)){//NGBEの登録行
				var re_ngbe=new RegExp('H:I(\\d+)\\tL(([^,\\\\]|\\\\(.|\\n))*)','gm');
				var rt_ngbe;
				while(rt_ngbe=re_ngbe.exec(usrprops[i])){//NGBE
					var tmp_label=(rt_ngbe[1]==rt_ngbe[2]||!ar_replace_sys.v2c_ngbe.use_label||rt_ngbe[2].length==0)?null:ar_replace_sys.v2c_ngbe.label_format.replace('%label%',rt_ngbe[2]);
					ls_ngbe[rt_ngbe[1]]=[rt_ngbe[1],tmp_label];
				}
			}
		}
	}
	ar_lists['#NGBE']={"data":ls_ngbe,"obj":ar_replace_sys.v2c_ngbe};
	ar_lists['#NGBE']['obj'].filename="#NGBE";
	ar_lists['#NGBE']['obj'].flag=0;//BEIDで比較
	
	v2cobj.lists['#NGBE']=ar_lists['#NGBE'];
	
	// ■NGBE.txt(Jane互換)の処理
	
	var tmp_filestr=v2c.readLinesFromFile(v2c.saveDir+fs+'NGBE.txt');
	if(tmp_filestr){
		v2c.println('readFile(sys#NGBE_J):NGBE.txt');
		ar_lists['#NGBE_J']={"data":{},"obj":ar_replace_sys.v2c_ngbe_j};
		for(var j=0,l=tmp_filestr.length;j<l;j++){
			var tmp_ar_line=tmp_filestr[j].split('<>');
			ar_lists['#NGBE_J']['data'][tmp_ar_line[0]]=tmp_ar_line;
		}
		v2cobj.lists['#NGBE_J']=ar_lists['#NGBE_J'];
		loaded=true;
	}
	
	v2c.setScriptObject(v2cobj);
	
	// ■メイン 2chからのsubjectについて各行を処理
	var ar_output=[],ar_output_age=[],ar_output_sage=[];
	var ar_flgls=[
		"creator.be.id",//BEIDで判別
		"creator.cap",//記者で判別
		"creator.name",//名前で判別
		"creator.id" //IDで判別
	];
	if(title_spacing){
		var space_px=fontwidth(' ');
		if(title_spacing_px<space_px){
			title_spacing=false;
		}else{
			title_spacing_px-=space_px-1;
		}
	}
	for(var i=0;i<ls_sbj.length;i++){//ls_sbj[i][0]全体[1]dat番[2]スレタイ[3]レス数
		var th_id=ls_sbj[i][1];
		var line_tmp,tmp_space,tmp_space_px;
		if(getidfromtitle===false){
			if(ls[th_id]){//スレ情報あり
				var ng_flag='',nm_flag='';
				ls[th_id].type=0;//とりあえず通常表示
				
				if(ls[th_id]["creator.be.id"]){//BEIDが存在する
					if(beid_padding){
						ls[th_id]["creator.be.id"]=jl.String.format(beid_format,jl.Integer.valueOf(ls[th_id]["creator.be.id"]));
					}
					if(ls[th_id]["creator.be.name"]&&bename_display){//BE名が存在する
						nm_flag+='[BE:'+ls[th_id]["creator.be.id"]+' '+ls[th_id]["creator.be.name"]+']';
					}else{
						nm_flag+='[BE:'+ls[th_id]["creator.be.id"]+']';
					}
					if(ar_replace_sys.newcomer.threshold>0){
						if(Number(ls[th_id]["creator.be.id"])>=ar_replace_sys.newcomer.threshold){
							nm_flag+=ar_replace_sys.newcomer.str_add;
							ls[th_id].type=ar_replace_sys.newcomer.th_shift;
						}
					}
				}else{//BEIDが存在しない
					if(bd.key+""=="poverty"){
						ng_flag+=ar_replace_sys.hidden.str_add;
						ls[th_id].type=ar_replace_sys.hidden.th_shift;//BE隠しかも
					}
				}
				if(ls[th_id]["creator.cap"])nm_flag+='〔'+ls[th_id]["creator.cap"]+'〕';//記者名が存在する
				
				for(var j in ar_lists){
					if(!ar_lists[j])continue;
					var ls_key=ar_lists[j]['obj'].flag;
					var ls_key_=ar_flgls[ls_key];
					if(ls_key_){
						if(ls[th_id][ls_key_]){//判別に使用する情報が存在する
							if(ar_lists[j]['data'][ls[th_id][ls_key_]]){//登録されている
								var ls_add=ar_lists[j]['data'][ls[th_id][ls_key_]][1];
								ng_flag+=(ls_add)?ls_add:ar_lists[j]['obj'].str_add;
								if(ls[th_id].type<ar_lists[j]['obj'].th_shift)ls[th_id].type=ar_lists[j]['obj'].th_shift;
							}
						}
					}
				}
				tmp_space=ng_flag+ls_sbj[i][2];
				if(title_spacing){
					tmp_space_px=fontwidth(tmp_space);
					while(tmp_space_px<title_spacing_px){
						tmp_space+=' ';
						tmp_space_px+=space_px;
					}
				}
				line_tmp=th_id+'.dat<>'+tmp_space+nm_flag+' ('+ls_sbj[i][3]+')';
			}else{//スレ情報なし 情報未取得
				line_tmp=th_id+'.dat<>'+ar_replace_sys.noinfo.str_add+ls_sbj[i][2]+' ('+ls_sbj[i][3]+')';
				ls[th_id]={type:ar_replace_sys.noinfo.th_shift}
			}
		}else{//スレタイからBEIDを抽出
			var ng_flag='',nm_flag='';
			var re=new RegExp('^(.*)\\[(\\d{5,10})\\]$','m');
			var rt;
			if(rt=re.exec(ls_sbj[i][2])){
				var beid_tmp=rt[2]+'';
				ls[th_id]={type:0,"creator.be.id":beid_tmp};//とりあえず通常表示
				for(var j in ar_lists){
					if(!ar_lists[j])continue;
					if(ar_lists[j]['data'][beid_tmp]){//登録されている
						var ls_add=ar_lists[j]['data'][beid_tmp][1];
						ng_flag+=(ls_add)?ls_add:ar_lists[j]['obj'].str_add;
						if(ls[th_id].type<ar_lists[j]['obj'].th_shift)ls[th_id].type=ar_lists[j]['obj'].th_shift;
					}
				}
				tmp_space=ng_flag+ls_sbj[i][2];
				line_tmp=th_id+'.dat<>'+tmp_space+nm_flag+' ('+ls_sbj[i][3]+')';
			}else{
				line_tmp=th_id+'.dat<>'+ar_replace_sys.noinfo.str_add+ls_sbj[i][2]+' ('+ls_sbj[i][3]+')';
				ls[th_id]={type:ar_replace_sys.noinfo.th_shift}
			}
		}
		switch(ls[th_id].type){//0:通常表示,1:上げる,2:下げる,3:非表示
			case 0://通常表示
				ar_output.push(line_tmp);
				break;
			case 1://上げる
				ar_output_age.push(line_tmp);//上げる
				break;
			case 2://下げる
				ar_output_sage.push(line_tmp);//下げる
				break;
			default ://非表示
				break;
		}
	}//for終わり
	//v2c.println(fontwidth2(" "));
	return ar_output_age.concat(ar_output).concat(ar_output_sage).join("\n")+"\n";
}

function in_array(ar,el){
	for(var i=0,l=ar.length;i<l;i++){
		if(i in ar && ar[i]===el){
			return true;
			break;
		}
	}
	return false;
}

function hash_md5(a){
	var dg=java.security.MessageDigest.getInstance("MD5");
	var s=new jl.String(a);
	var hash=dg.digest(s.getBytes());
	var hash2="";
	var jli=jl.Integer;
	for(var i=0;i<hash.length;i++){
		hash2+=jli.toHexString(hash[i] & 0xff);
	}
	return hash2;
}

function fontwidth(str){
	var bi=new awt.image.BufferedImage(100,100,awt.image.BufferedImage.TYPE_INT_RGB);
	var g2d=bi.createGraphics();
	g2d.setFont(new awt.Font("ＭＳ Ｐゴシック",awt.Font.PLAIN,12));
	var fm=g2d.getFontMetrics();
	var width=0;
	var data=new jl.String(str);
	for(var j=0;j<data.length();j++){
		width+=fm.charWidth(data.charAt(j));
	}
	return width;
}
function fontwidth2(str){
	var g=awt.Graphics;
	//g.setFont(new awt.Font("ＭＳ Ｐゴシック",awt.Font.PLAIN,12));
	var fm=g.getFontMetrics();
	//awt.Graphics.setFont(new awt.Font("ＭＳ Ｐゴシック",awt.Font.PLAIN,12));
	//var fm=awt.Component.getFontMetrics(new awt.Font("ＭＳ Ｐゴシック",awt.Font.PLAIN,12));
	return fm.stringWidth(str);
}
//BE情報などの付加位置
//スレ情報取得が間に合わなかったスレタイは透明あぼーん
